<?php

namespace OrganizationsManagement\Factory;

use OrganizationsManagement\Service\Teknisa\NewCode;
use Teknisa\Model\Teknisa\Entities\SlaclienteAlert as SlaclienteAlertEntity;
use OrganizationsManagement\Util\InstanceProvider;

class SlaclienteAlert
{
    /**
     *
     * Tem que verificar se ta certo
     */

    public function __construct()
    {
    }

    /**
     * @param $cdcliente
     * @param $cdgrupfase
     * @param $cdassunto
     * @param $cdcomplexid
     * @param $idRespProdEstrut
     * @param $structureTypeId
     * @param $qthorasalert
     * @param $idantesdepois
     * @param $idativo
     * @return SlaclienteAlertEntity
     */
    public function create($cdcliente, $cdgrupfase, $cdassunto, $cdcomplexid, $idRespProdEstrut, $structureTypeId,
                           $qthorasalert, $idantesdepois, $idativo): SlaclienteAlertEntity
    {
        $environment     = InstanceProvider::getLibEnvironment();
        $nrorg    = $environment->getCurrentOrganizationId();
        $currentOperator = $environment->getCurrentUserId();
        $dtAtual = new \DateTime();

        $entity = new SlaClienteAlertEntity();

        /** @var NewCode $newCodeService */
        $newCodeService = InstanceProvider::getService()->getNewCode();
        $id = $newCodeService->getCodeByTableName('SLACLIENTE_ALERT', $nrorg, 1, 10, true);

        $entity->setid($id);
        $entity->setCdcliente($cdcliente);
        $entity->setCdgrupfase($cdgrupfase);
        $entity->setCdassunto($cdassunto);
        $entity->setCdcomplexid($cdcomplexid);
        $entity->setIdRespProdEstrut($idRespProdEstrut);
        $entity->setStructureTypeId($structureTypeId);
        $entity->setQthorasalert($qthorasalert);
        $entity->setIdantesdepois($idantesdepois);

        $entity->setNrorg($nrorg);
        $entity->setDtinclusao($dtAtual);
        $entity->setDtultatu($dtAtual);
        $entity->setNrorginclusao($nrorg);
        $entity->setCdoperinclusao($currentOperator);
        $entity->setNrorgultatu($nrorg);
        $entity->setCdoperultatu($currentOperator);
        $entity->setIdativo($idativo);
        return $entity;
    }

    public function update(SlaClienteAlertEntity $slaclienteAlert, $idRespProdEstrut, $structureTypeId,
                           $qthorasalert, $idantesdepois, $idativo)
    {
        $environment     = InstanceProvider::getLibEnvironment();
        $nrorg    = $environment->getCurrentOrganizationId();
        $currentOperator = $environment->getCurrentUserId();
        $dtAtual = new \DateTime();

//        $slaclienteAlert->setCdcliente($cdcliente);
//        $slaclienteAlert->setCdgrupfase($cdgrupfase);
//        $slaclienteAlert->setCdassunto($cdassunto);
//        $slaclienteAlert->setCdcomplexid($cdcomplexid);
        $slaclienteAlert->setIdRespProdEstrut($idRespProdEstrut);
        $slaclienteAlert->setStructureTypeId($structureTypeId);
        $slaclienteAlert->setQthorasalert($qthorasalert);
        $slaclienteAlert->setIdantesdepois($idantesdepois);

        $slaclienteAlert->setNrorg($nrorg);
        $slaclienteAlert->setDtultatu($dtAtual);
        $slaclienteAlert->setNrorgultatu($nrorg);
        $slaclienteAlert->setCdoperultatu($currentOperator);
        $slaclienteAlert->setIdativo($idativo);
        return $slaclienteAlert;
    }
}
