<?php


namespace OrganizationsManagement\Repository;


use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityRepository;
use Doctrine\Persistence\ObjectRepository;
use OrganizationsManagement\Util\InstanceProvider;

class RepositoryBase
{
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * @var EntityRepository|ObjectRepository
     */
    private $repository;

    public function __construct($entityName)
    {
        $this->entityManager = InstanceProvider::getEntityManager();
        $this->repository = $this->entityManager->getRepository($entityName);
    }

    /**
     * @param $id
     * @return object|null
     */
    public function find($id): ?object
    {
        return $this->repository->find($id);
    }

    /**
     * @param array $criteria
     * @param array|null $orderBy
     * @param null $limit
     * @param null $offset
     * @return array|object[]
     */
    public function findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null): array
    {
        return $this->repository->findBy($criteria, $orderBy, $limit, $offset);
    }

    /**
     * @param array $criteria
     * @param array|null $orderBy
     * @return object|null
     */
    public function findOneBy(array $criteria, array $orderBy = null): ?object
    {
        return $this->repository->findOneBy($criteria, $orderBy);
    }

}
