<?php
namespace OrganizationsManagement\Service;

use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Repository\Classification as ClassificationRepository;

class Classification {
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var ClassificationRepository
     */
    private $classificationRepository;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     * @param ClassificationRepository $classificationRepository
     */
    public function __construct(EntityManager $entityManager, ClassificationRepository $classificationRepository)
    {
        $this->entityManager = $entityManager;
        $this->classificationRepository = $classificationRepository;
    }

    public function findClassification($onlySubject = null): array
    {
        if ($onlySubject) {
            return $this->classificationRepository->findClassificationOnliWithSubject();
        }
        return $this->classificationRepository->buildResponseData([]);
    }
}
